// tst_date.cc  
// author: Bernt A Oedegaard

#include "date.h"

void compare_dates (date d1, date d2) {
   cout << " Comparing " << d1 << "and" << d2 << endl;
   cout << "  is" << d1 <<"equal to      "  << d2 ;
   if (d1==d2){ cout << "YES"; } else { cout << "NO"; };
   cout << endl;
   cout << "  is" << d1 <<"different from"  << d2 ;
   if (d1!=d2){ cout << "YES"; } else { cout << "NO"; };
   cout << endl;
   cout << "  is" << d1 <<"less than     "  << d2 ;
   if (d1<d2){ cout << "YES"; } else { cout << "NO"; };
   cout << endl;
   cout << "  is" << d1 <<"greater than  "  << d2 ;
   if (d1>d2){ cout << "YES"; } else { cout << "NO"; };
   cout << endl;
};

void test_date_comparisons (){
   cout << "TESTING DATE COMPARISONS " << endl;
   date d1(930725);
   date d2(930810);
   compare_dates (d1,d2);
   compare_dates (d1,d1);
   cout << "DONE TESTING DATE COMPARISONS " << endl;
};

void test_date_simple(){
   cout << "TESTING DATE SIMPLE " << endl;
   cout << " construction: date(1,1,1998):" << date(1,1,1998) <<endl;
   cout << " construction: date(19980101):" << date(19980101) <<endl;
   cout << " increment: ++date(1,1,1998):" << ++date(1,1,1998) << endl;
   cout << " decrement: --date(1,1,1998):" << --date(1,1,1998) << endl;
   cout << "DONE TESTING DATE SIMPLE " << endl;
}

void test_adding_subtracting_date(){
   cout << "TESTING DATE CHANGING " << endl;
   date d(1,1,1990);
   cout << " next date to           " << d << " is    " << next_date(d) << endl;
   cout << " add 25 days to         " << d << " gives " << d+25 << endl;
   cout << " add 125 days to        " << d << " gives " << d+125 << endl;
   cout << " previous date to       " << d << " is    " << previous_date(d) << endl;
   cout << " subtract 25 days from  " << d << " gives " << d-25 << endl;
   cout << " subtract 125 days from " << d << " gives " << d-125 << endl;
   cout << " next month relative to   " << d << " is    " << next_month(d) << endl;
   cout << " end of month relative to " << d << " is    " << end_of_month(d) << endl;
   cout << " add 6 months relative to " << d << " is    " << add_months(d,6) << endl;
   cout << "DONE TESTING DATE CHANGING " << endl;
};

void test_date() {
   cout << "TESTING DATE " << endl;
   test_date_simple();
   test_date_comparisons();
   test_adding_subtracting_date();
   cout << "DONE TESTING DATE " << endl;
};

