// file tst_dated_util.cc 
// testing utilities for dated<> class

#include "dated_util.h"

void test_pick_before_after() {
    cout << "TESTING picking before after " << endl;
    dated<double> dobs = beginning_of_month_observations(create_test_series_of_dated(300));
    cout << " original series " << endl;
    cout << dobs;
    cout << " picked ones after " << dobs.date_at(5) << endl;
    cout << observations_after(dobs,dobs.date_at(5)); 
    cout << " picked ones before " << dobs.date_at(5) << endl;
    cout << observations_before(dobs,dobs.date_at(5)); 
    cout << "DONE test pickeing before after " << endl;
};

void test_end_of_year() {
    cout << "TESTING end of year " << endl;
    dated<double> dobs     = create_test_series_of_dated(1000);
    cout << " generated " << dobs.size() << " observations, now pick annual" << endl; 
    dated<double> eoy_dobs = end_of_year_observations(dobs);
    cout << eoy_dobs;
    cout << "DONE testing end of year " << endl;
};

void test_pick_monthly() {
    cout << "TESTING picking monthly " << endl;
    dated<double> dobs     = create_test_series_of_dated(100);
    cout << " generated " << dobs.size()  << " observations " << endl;
    cout << " beginning of month" << endl; 
    cout <<  beginning_of_month_observations(dobs);
    cout << " end of month" << endl; 
    cout <<  end_of_month_observations(dobs);
    cout << "DONE TESTING monthly " << endl;
};

void test_pick_matching(){
   cout << "TEST: pick matching observations " << endl;
   cout << "  given a vector of dates, find observations on same date " << endl; 
   dated<double> dobs     = create_test_series_of_dated(100);
   vector<date> dates;
   dates.push_back(dobs.date_at(0));
   dates.push_back(dobs.date_at(2));
   dates.push_back(dobs.date_at(4));
   dated<double> picked_obs = observations_matching_dates(dobs,dates);
   cout << " found " << picked_obs.size()<< " observations " << endl;
   cout << picked_obs;
   cout << "DONE TEST: pick matching observations " << endl;
};

void test_dated_util(){
   test_pick_before_after(); 
   test_end_of_year() ;
   test_pick_monthly() ;
   test_pick_matching();
};
